\documentclass{article}
\usepackage[utf8]{inputenc}
\usepackage{graphicx}
\usepackage[ngerman]{babel}


\title{Documentation of Footprint conformance checking product}
\author{Alain Mahieu, Hieu Le, Jeongkyeong Park, Liangkun He and Tomasz Karg}

\date{\today}

\begin{document}


\maketitle

\section{Purpose of the Project}
Our project aims to provide our customer with a tool to perform footprint based conformance checking. It is supposed to take eventlogs and check them against given process models or generated process models in form of process trees. For that our software needs to handle both process trees and eventlogs. The outcome is supposed to be footprint tables for the eventlog and the process tree with highlighted deviations. 

\section{Approach}
The main idea of our software is to generate footprint matrices from both the given eventlog and the process tree and 
compare them against each other. After that it displays the model, the footprints and highlights the deviations in the footprints. 
In order to do that the tasks are separated in three major fields. The first field is the footprint generator that is able to extract
the footprint matrices from a process tree and an eventlog. The second field is the footprint comparator that can check two given
footprint matrices against each other and give back the deviations. The third field is the webinterface that deal with displaying 
the objects and highlighting the deviations.

\subsection{Footprint Generator}
The Implementation of the footprint generator can be found in \glqq ../Conformance\_Checker/FootprintGenerator.py \grqq. It holds all the main 
functionalities to extract footprint tables from eventlogs and process trees. As in input it expects an eventlog object as given by the pm4Py 
library or a process tree object as given by the pm4Py library respectively. The output for both is a pandas Dataframe that has the names of activities
ordered alphabetically as Index and Columns. Each value of the dataframe corresponds to a value indicating the relationship of the respected two activities.
The values go from 1 to 4 meaning when a is the row and b is the column: 1 means a is directly followed by b, 2 means b is directly followed by a, 3 means 
a is directly followed by b and b is directly followed by a and 4 for means neither is ever directly followed by the other. These values will later be displayed
as the symbols $\rightarrow$ , $\leftarrow$, || and \# respectively.

\subsubsection{Eventlogs}
To extract a footprint from an event log it expects an eventlog object from pm4Py library. Once read in it calculates a directly follows
graph that yields all information needed for footprints. The outcome is a list of tuples of the form (a, b) that tells us the activity a is directly 
followed by the activity b. All that is done next is to go through the list and make an entry in the dataframe at the corresponding place with the corresponding value 
as stated above. for every pair of activities that has no entry in the directly follow graph we put the value 4.

\subsubsection{Process trees}
To extract footprints from process trees it expects a process tree object provided by the pm4Py library. It goes through the tree recursevly each node calling the same 
functuion on their child nodes. The initiation is done for the leaf nodes that corresponds to the activities. The results are passed back to the parent nodes containing 
footprints from the subtrees and teh activities that occur in the subtrees. Respectively to what node operator the parent node is it calculates new footprints based on 
the result of all his child nodes. By the time we get to the root node we have all footprints that the process tree describes.

\subsection{Footprint Comparator}
Next in line is the Footprint Comparator that takes the calculated footprints and compares them agains each other. For that it checks every value of the first table to 
the corresponding value of the second table producing a new binary value with 0 indicating no deviation and 1 indicating a deviation. The output is a pandas Dataframe 
of the same shape as the footprints. This frame can then be used as an overlay to indicate which places in the footprint table has to be highlighted. 

\subsection{Webinterface}
The last part is the webinterface itself. It can take uploads of eventlogs that needs to be checked. It passes it down to the functionalities stated above to calculate the footprints
and the deviations. It takes the result and displays two footprint tables one for the eventlog and one for the process tree. It uses the dataframe from the comparator to tell what places
in the process tree footprint needs to be highlighted as deviation. This highlighting is done with the color pink. Besides the display of the footprint tables it provides a tab that
displays the process tree. 

\section{How to use the product}
Our product can be retrieved from https://git.rwth-aachen.de/minhhieu.lehoang/footprints-conformance-checking. After pulling this project, open the footprints-conformance-checking project by a Python IDE. We recommend to use PyCharm. Then compile the server.py in server module. After compiling the server.py, go to the localhost:5000 by your web browser. On this web interface, there are 4 options:
\begin{enumerate}
    \item Choose File: choosing your .csv file. Here we have included the running-example.csv in our project (../tests/test\_input/synthetic/running-example.csv).
    \item Upload: uploading the chosen file to process.
    \item Process tree: in this tab, you can see the image of process tree of the uploaded file. 
    \item Footprint matrices: in this tab, you can see 2 matrices. The first matrix will represent the footprint matrix extracted from the eventlog. The second one will represent the footprint matrix extracted from the process tree with highlighting (in pink) of deviation in compare with the first matrix.

\end{enumerate}
The screenshots of each step will be shown as follows:
\begin{figure}[h]
    \centering
    \includegraphics[width=\textwidth]{media/pycharm_1st.png}
    \caption{After opening project}
    \label{fig:my_label}
\end{figure}
\begin{figure}[h]
    \centering
    \includegraphics[width=\textwidth]{media/execute_server.png}
    \caption{server.py}
    \label{fig:my_label}
\end{figure}
\begin{figure}[h]
    \centering
    \includegraphics[width=\textwidth]{media/frontend.png}
    \caption{The web interface of our product}
    \label{fig:my_label}
\end{figure}
\begin{figure}[h]
    \centering
    \includegraphics[width=\textwidth]{media/upload_input.png}
    \caption{Open the csv file}
    \label{fig:my_label}
\end{figure}
\begin{figure}[h]
    \centering
    \includegraphics[width=\textwidth]{media/pt.png}
    \caption{The process tree of the event log}
    \label{fig:my_label}
\end{figure}
\begin{figure}[h]
    \centering
    \includegraphics[width=\textwidth]{media/fm.png}
    \caption{2 footprint matrices. The first one is from the event log, the second one is from the process tree}
    \label{fig:my_label}
\end{figure}


\end{document}
